/*
******************************************************************************
 * 
 *  GGI_ART extension internals
 * 
 *  Copyright 2000, Eric Faurot             
 *
******************************************************************************
*/

#ifndef _GGIART_INT_H
#define _GGIART_INT_H

#include <ggi/internal/internal.h>
#include <ggi/internal/ggiart_debug.h>
#include <ggi/ggiart.h>

__BEGIN_DECLS

/* Exported variables */
#ifdef BUILDING_GGIART
extern ggi_extid    _ggiartID;
#else
IMPORTVAR ggi_extid _ggiartID;
#endif

__END_DECLS

typedef void(ggiart_func_render_svp)(ggi_visual_t vis,
				     const ggiart_svp_t svp,
				     const ggiart_uta_t bbox,
				     const ggiart_rop_t rop);

typedef void(ggiart_func_render_buffer)(ggi_visual_t vis,
					const ggiart_buffer_t buf,
					const double affine[6],
					const ggiart_uta_t bbox,
					const int alpha);

typedef void (ggiart_func_fillscreen)(ggi_visual_t vis,
				      const ggiart_uta_t bbox);

typedef struct ggiartpriv {
  ggiart_func_render_svp     * render_svp;
  ggiart_func_render_buffer  * render_buffer;
  ggiart_func_fillscreen     * fillscreen;
} ggiartpriv;

/* Used to access the ggiartpriv structure for a particular visual. */
#define LIBGGI_GGIARTEXT(vis) ((ggiartpriv *)LIBGGI_EXT((vis),_ggiartID))

#endif /* _GGIART_INT_H */
